#
# spec file for package freeswan (Version 1.91_0.9.2)
# 
# Copyright  (c)  2001  SuSE GmbH  Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
# 
# please send bugfixes or comments to feedback@suse.de.
#

# neededforbuild  autoconf bin86 gmp kernel-source modutils openssl openssl-devel
# usedforbuild    aaa_base aaa_dir autoconf automake base bash bin86 bindutil binutils bison bzip compress cpio cpp cracklib cyrus-sasl db devs diffutils e2fsprogs file fileutils findutils flex gawk gcc gdbm gdbm-devel gettext glibc glibc-devel gmp gpm gppshare grep groff gzip kbd kernel-source less libtool libz m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg openssl openssl-devel pam pam-devel patch perl ps rcs readline rpm sendmail sh-utils shadow strace syslogd sysvinit texinfo textutils timezone unzip util-linux vim

Name:         freeswan
%define fversion 1.91
%define xversion 0.9.2
Version:      1.91_0.9.2
Release:      83
Copyright:    GNU GPL
Group:        Networking/Security
Provides:     pluto klips ipsec VPN
Autoreqprov:  on
Summary:      IPsec implementation which allows building VPNs
Source:		ftp://ftp.xs4all.nl/pub/crypto/freeswan/freeswan-%{fversion}.tar.gz
Source1:	ftp://ftp.xs4all.nl/pub/crypto/freeswan/freeswan-%{fversion}.tar.gz.sig
Source2:	RFCs.tar.bz2
Source3:	rc.config.ipsec
Source4:	http://www.strongsec.com/freeswan/x509patch-%{xversion}-freeswan-%{fversion}.tar.gz
Source5:	install-x509.html
Source9:	fswandes.spec_
Patch:		freeswan-%{fversion}.diff
Patch1:		freeswan-insec.des.dif
Patch2:		x509-%{xversion}.diff
Patch3:		freeswan-%{fversion}-lx249.diff
URL:		http://www.xs4all.nl/~freeswan/
Prefix:         /usr
#BuildRoot:	/var/tmp/%{name}-buildroot

%description
FreeS/WAN is an IPsec implementation which allows building Virtual
Private Networks (VPNs). A typical VPN setup consists of two trusted
networks, connected over an insecure network, typically the Internet.
FreeS/WAN allows you to create an encrypted tunnel through the
insecure area. Unlike CIPE, it is interoperable with other operating
systems or even routers IPsec implementations.
There is no longer support for the insecure DES algorithm. For
interoperability your partner also needs to understand 3DES encryption.
SuSE has added the X.509 support (http://www.strongsec.com/freeswan/)
for you.
It contains strong cryptographic routines. The US government does not
allow to (re)export this software out of the US, regardless of where it
has been written. Nowadays, you may register with the US authorities
and may get granted a license to export it though.
Some other countries (Russia, France, ...) may also have regulations
preventing the import, export or usage of this piece of software.

Authors:
--------
    John Gilmore <gnu@toad.com>
    Henry Spencer <henry@spsystems.net>
    Richard Guy Briggs <rgb@conscoop.ottawa.on.ca>
    Hugh Redelmeier <hugh@mimosa.com>
    Sandy Harris <sandy.harris@sympatico.ca>
    Hugh Daniels <hugh@toad.com>

SuSE series: sec

%package -n km_freeswan
Summary:      IPsec implementation which allows building VPNs
Group:        System Environment/Kernel

%description -n km_freeswan
FreeS/WAN is an IPsec implementation which allows building Virtual
Private Networks (VPNs). A typical VPN setup consists of two trusted
networks, connected over an insecure network, typically the Internet.
FreeS/WAN allows you to create an encrypted tunnel through the
insecure area. Unlike CIPE, it is interoperable with other operating
systems or even routers IPsec implementations.
There is no longer support for the insecure DES algorithm. For
interoperability your partner also needs to understand 3DES encryption.
SuSE has added the X.509 support (http://www.strongsec.com/km_freeswan/)
for you.
It contains strong cryptographic routines. The US government does not
allow to (re)export this software out of the US, regardless of where it
has been written. Nowadays, you may register with the US authorities
and may get granted a license to export it though.
Some other countries (Russia, France, ...) may also have regulations
preventing the import, export or usage of this piece of software.

Authors:
--------
    John Gilmore <gnu@toad.com>
    Henry Spencer <henry@spsystems.net>
    Richard Guy Briggs <rgb@conscoop.ottawa.on.ca>
    Hugh Redelmeier <hugh@mimosa.com>
    Sandy Harris <sandy.harris@sympatico.ca>
    Hugh Daniels <hugh@toad.com>

SuSE series: suse

%define kversion %(uname -r)
%define kmoddir %(test `uname -r | cut -c1,3 ` -ge 24 && echo /lib/modules/`uname -r`/kernel/net/ipv4 || echo /lib/modules/`uname -r`/ipv4)
%prep
%setup -b4 -b0 -n freeswan-%{fversion}
%patch -p1
%patch3 -p1
#%patch1 -p1
patch -p0 < ../x509patch-%{xversion}-freeswan-%{fversion}/pluto.diff
patch < ../x509patch-%{xversion}-freeswan-%{fversion}/auto.diff utils/auto
patch < ../x509patch-%{xversion}-freeswan-%{fversion}/fswcert/_confread.patch utils/_confread
chown 0.0 -R *
mv doc/README doc/README.doc
cp -p $RPM_SOURCE_DIR/RFCs.tar.bz2 .
echo KVERSION:%{kversion}
echo KMODDIR:%{kmoddir}
cd ../x509patch-%{xversion}-freeswan-%{fversion}
%patch2 -p1 
mv README README.x509
mv CHANGES CHANGES.x509
cd fswcert
mv README README.fswcert
mv CHANGES CHANGES.fswcert

%build
make programs prefix=/usr DESTDIR=$RPM_BUILD_ROOT
cd ../x509patch-%{xversion}-freeswan-%{fversion}/fswcert
make

%install
make install prefix=/usr DESTDIR=$RPM_BUILD_ROOT
#make minstall
install -o root -g root -m 755 -d $RPM_BUILD_ROOT/%{kmoddir}
#install -o root -g root -m 755 -d $RPM_BUILD_ROOT/lib/modules/%{kversion}/kernel/ipv4
#install -o root -g root -m 644 /usr/src/linux/modules/ipsec.o $RPM_BUILD_ROOT/lib/modules/%{kversion}/ipv4/
#install -o root -g root -m 644 /usr/src/linux/net/ipsec/ipsec.o $RPM_BUILD_ROOT/%{kmoddir}
#strip -S $RPM_BUILD_ROOT/%{kmoddir}/ipsec.o
cd ../x509patch-%{xversion}-freeswan-%{fversion}/fswcert
make install DESTDIR=$RPM_BUILD_ROOT
ln -sf ../../etc/init.d/ipsec $RPM_BUILD_ROOT/usr/sbin/rcipsec
#ln -sf ../ipsec /sbin/init.d/rc0.d/K35ipsec
#ln -sf ../ipsec /sbin/init.d/rc1.d/K35ipsec
#ln -sf ../ipsec /sbin/init.d/rc6.d/K35ipsec
#ln -sf ../ipsec /sbin/init.d/rc2.d/S35ipsec
#ln -sf ../ipsec /sbin/init.d/rc3.d/S35ipsec
#ln -sf ../ipsec /sbin/init.d/rc4.d/S35ipsec
#ln -sf ../ipsec /sbin/init.d/rc5.d/S35ipsec
#rm -f $RPM_BUILD_ROOT/dev/ipsec
#mknod $RPM_BUILD_ROOT/dev/ipsec c 36 0; chown 0.0 $RPM_BUILD_ROOT/dev/ipsec; chmod 200 $RPM_BUILD_ROOT/dev/ipsec
install -m 644 $RPM_SOURCE_DIR/rc.config.ipsec /var/adm/fillup-templates/rc.config.ipsec
install -d -m 700 -o root -g root $RPM_BUILD_ROOT/etc/ipsec.d/cacerts
install -d -m 700 -o root -g root $RPM_BUILD_ROOT/etc/ipsec.d/crls
#sed "s#KVERSION#`uname -r`#g" <$RPM_SOURCE_DIR/freeswan.files.in >freeswan.files
#%files -f freeswan.files
# Make km_freeswan subpackage
cd ../../freeswan-%{fversion}
make clean
install -o root -g root -d $RPM_BUILD_ROOT/usr/src/kernel-modules/zz_freeswan
cp -ax Makefile* klips utils lib libdes zlib $RPM_BUILD_ROOT/usr/src/kernel-modules/zz_freeswan/

%files
#/dev/ipsec
#%{kmoddir}/ipsec.o
/usr/sbin/ipsec
/usr/sbin/rcipsec
/usr/lib/ipsec/
%doc %{_mandir}/man3/ipsec*
%doc %{_mandir}/man5/ipsec*
%doc %{_mandir}/man8/ipsec*
%config /etc/init.d/ipsec
%config(noreplace) /etc/ipsec.secrets
%config(noreplace) /etc/ipsec.conf
/var/adm/fillup-templates/rc.config.ipsec
%dir /etc/ipsec.d/
%dir /etc/ipsec.d/cacerts
%dir /etc/ipsec.d/crls
%doc BUGS CHANGES COPYING CREDITS INSTALL README README.SuSE
%doc doc/*.html doc/README.doc doc/standards doc/Makefile
%doc doc/*.notes doc/examples doc/prob.report doc/iab-iesg.stmt RFCs.tar.bz2
%doc ../x509patch-%{xversion}-freeswan-%{fversion}/fswcert/README.fswcert
%doc ../x509patch-%{xversion}-freeswan-%{fversion}/fswcert/CHANGES.fswcert
%doc ../x509patch-%{xversion}-freeswan-%{fversion}/README.x509
%doc ../x509patch-%{xversion}-freeswan-%{fversion}/CHANGES.x509
%doc $RPM_SOURCE_DIR/install-x509.html

%files -n km_freeswan
/usr/src/kernel-modules/zz_freeswan/

%clean
make unpatch
#rm -rf $RPM_BUILD_ROOT/freeswan-%version
#rm -rf $RPM_BUILD_DIR

%post
sbin/insserv etc/init.d/ipsec
echo "Updating etc/rc.config..."
if [ -x bin/fillup ] ; then
  bin/fillup -q -d = etc/rc.config var/adm/fillup-templates/rc.config.ipsec
else
  echo "ERROR: fillup not found. This should not happen. Please compare"
  echo "etc/rc.config and var/adm/fillup-templates/rc.config.ipsec and "
  echo "update by hand."
fi
#if [ -x sbin/depmod -a -e lib/modules/`bin/uname -r`/modules.dep ] ; then
#  chroot . /sbin/depmod -a 2>/dev/null
#fi
exit 0
#%preun
#usr/sbin/rcipsec stop

%postun
sbin/insserv etc/init.d/

%changelog -n freeswan
* Fri Sep 21 2001 - garloff@suse.de
- Document that right/leftfirewall=yes should not be used
  (It uses ipfwadm!)
* Thu Sep 13 2001 - garloff@suse.de
- Work around yet another min/max change in the kernel :-(
* Mon Aug 20 2001 - garloff@suse.de
- Include patch for linux-2.4.9 (min/max issue)
- Update to x509-0.9.2:
  * dist. names can be in LDAP, openssl x509 -subject or old
  binary format.
  * del revoked cert keys upon renewal of ISAKMP SA.
  * log peer IDs of ISAKMP SAs (for roadwarriors).
  * fswcert 0.6.
* Mon Aug 06 2001 - garloff@suse.de
- Update to x509-0.9.1 patch: Handle missing directories properly.
- Link dynamically against openssl (-lcrypto)
- Make oldconfig after installing module, this way leaving
  consistent /proc/config.gz.
* Wed Jul 25 2001 - garloff@suse.de
- Added some $rc_done to setup script and correct exit status for
  rcipsec status to be 3 if stopped. Don't fail on already started
  service. Implement reload (as restart).
- Include /etc/ipsec.d/crls directory.
* Mon Jul 23 2001 - garloff@suse.de
- Fixed another missing dep which broke make -j builds.
* Mon Jul 23 2001 - garloff@suse.de
- Shutdown script does not return error any more if ipsec is not
  running.
- Allow parallel builds (make -j) of kernel module by correctly
  specifying dependencies
- Make kernel module compilation more robust by first doing an
  oldconfig, inserting the patches and then passing the arguments
  with yes to oldconfig again.
* Sat Jul 21 2001 - garloff@suse.de
- fswcert needs to link against libdl as new openssl needs it.
* Sat Jul 21 2001 - garloff@suse.de
- Add /etc/ipsec.d/cacerts dir to make X.509 0.9 patch work. (#9371)
- Disable stopping of service in %%preun script. (Leads to updating
  problems)
* Tue Jul 17 2001 - garloff@suse.de
- Remove k_deflt from #neededforbuild.
* Mon Jul 16 2001 - garloff@suse.de
- x509patch-0.9:
  Major release supporting CA certificate trust chains,
  certificate revocation lists (CRLs), and the subjectAltNames
  IpAddress (IPV4_ADDR), DnsName (FQDN), and rfc822Name (USER_FQDN)
* Fri Jul 13 2001 - garloff@suse.de
- Use /dev/urandom when calling rsasigkey during package build.
* Thu Jul 12 2001 - garloff@suse.de
- The 2.4 kernel module problems are solved in 1.91; therefore
  update to 1.91.
- Update x509 patch accordingly (0.8.5_1.91)
- Update x509 install docu
- Update to FreeS/WAN 1.91:
  * fixed memory leaks in KLIPS (kernel module)
  * works with current 2.4.5 kernel
  * fix spin-lock bug for SMP kernels (AH+ESP or compression)
  [ ... and many more. See CHANGES.]
* Thu May 10 2001 - garloff@suse.de
- bzip2 some sources. (Not freeswan-1.9.tar, as we want to leave
  the .sig intact.)
- km_freeswan builds in zz_freeswan now, i.e. as last module
  (preventing risks with lernel patching)
* Wed May 09 2001 - garloff@suse.de
- Change build process to use a km_freeswan subpackage to build
  kernel module.
* Fri Apr 27 2001 - garloff@suse.de
- Added #if KERNEL_VERSION_CODE statements to kernel module to
  make it compile with 2.4.4pre.
- Make kernel dep and version before everything else.
- Use of %%%%{kmoddir} to account for different places of kernel
  modules in 2.4 vs. 2.2.
* Thu Apr 26 2001 - garloff@suse.de
- Don't use macros in version number
- Update FreeS/WAN to 1.9 for recent 2.4.x support
- Update to corresponding X.509 support (0.8.2)
* Thu Apr 12 2001 - garloff@suse.de
- Also apply _confread.patch from the X.509 patches.
* Wed Dec 06 2000 - garloff@suse.de
- Made module compile with 2.4.0-test11+
  (IpDefaultTTL and pkt_bridged issues)
* Wed Dec 06 2000 - garloff@suse.de
- Update to FreeS/WAN 1.8
  * no more /dev/ipsec needed
  * support for RSA keys
  * support for recent 2.4.0-test kernels
  * many bugfixes ...
- Removed -g for kernel module generation
- Support for X.509 certificates w/ the strongsec patch
  (linked statically against openssl to avoid dependency)
- LSB conforming init script
- fswandes dropped
* Fri Nov 10 2000 - ro@suse.de
- neededforbuild modules modutils
* Thu Oct 19 2000 - garloff@suse.de
- Correct installation path for init.d scripts.
* Tue Jun 20 2000 - ro@suse.de
- fixed make oldconfig
* Mon Jun 05 2000 - garloff@suse.de
- Fix installation.
* Sat May 27 2000 - garloff@suse.de
- Makefile hack to avoid the compilation of all modules.
* Sat May 27 2000 - garloff@suse.de
- Upgrade to FreeS/WAN-1.4
- Include RFCs.tar.gz
* Thu Mar 16 2000 - garloff@suse.de
- Fix _all_ paths to expect files in /usr instead of /usr/local
* Wed Feb 16 2000 - garloff@suse.de
- Updated to FreeS/WAN-1.3
- Kernel config now using the config distributed w/ k_deflt
* Thu Feb 10 2000 - ro@suse.de
- replaced kernmod by k_deflt
* Wed Feb 09 2000 - ro@suse.de
- adapted kernel-patch (context in Space.c)
- tweaked kernel-config handling
* Mon Dec 13 1999 - ro@suse.de
- added gmp-fixes for ppc
* Mon Dec 13 1999 - ro@suse.de
- added configs for alpha and ppc
* Fri Dec 10 1999 - garloff@suse.de
- fswandes now actually has DES support enabled.
* Thu Dec 09 1999 - garloff@suse.de
- Make fswandes a module-only package, requiring freeswan.
* Wed Dec 08 1999 - garloff@suse.de
- Make statements about the insecurity of DES in the package
  description and rename the DES version to freeswan-insecure-des
* Wed Dec 08 1999 - garloff@suse.de
- Renamed spec for insecure DES enabled FreeS/WAN to fswandes.
* Tue Dec 07 1999 - garloff@suse.de
- Provide patch to enable insecure DES, but DON'T apply it.
- Update config to reflect latest config options.
* Tue Oct 26 1999 - garloff@suse.de
- Fixed setup script to use SuSE return codes.
- %%kversion now set correctly.
* Mon Oct 18 1999 - garloff@suse.de
- Changed file list handling.
* Sat Oct 16 1999 - garloff@suse.de
- Initial creation of freeswan package (FreeS/Wan-1.1).
  Tweaked Makefile to only compile a module and to install in /usr.
  README.SuSE, config and rc.config.ipsec created.
%changelog -n fswandes
* Fri Nov 10 2000 - ro@suse.de
- neededforbuild modules modutils
* Thu Oct 19 2000 - garloff@suse.de
- Correct install path for init.d scripts.
* Tue Jun 20 2000 - ro@suse.de
- fixed make oldconfig
* Thu Mar 16 2000 - garloff@suse.de
- Remove /usr/local refs.
* Wed Feb 16 2000 - garloff@suse.de
- Updated to FreeS/WAN-1.3
- Kernel config now using the config distributed w/ k_deflt
* Thu Feb 10 2000 - ro@suse.de
- replaced kernmod by k_deflt
* Wed Feb 09 2000 - ro@suse.de
- adapted kernel-patch (context in Space.c)
- tweaked kernel-config handling
* Mon Dec 13 1999 - ro@suse.de
- use configs for i386/ppc/alpha
* Thu Dec 09 1999 - garloff@suse.de
- created package
